routes/web.php
<?php

use App\Http\Controllers\AlumnoController;
use App\Http\Controllers\CursoController;
use App\Http\Controllers\PerteneceController;
use App\Http\Controllers\PracticaController;
use App\Http\Controllers\PresentaController;
use App\Models\Practica;
use Illuminate\Support\Facades\Route;

Route::get('/', function () {
    return view('index');
})->name('inicio');

// enrutamiento para controlador alumno
Route::resource('alumno', AlumnoController::class);

// enrutamiento para controlador curso
Route::resource('curso', CursoController::class);

// enrutamiento para todo
Route::resource('practica', PracticaController::class);
Route::resource('presenta', PresentaController::class);
Route::resource('pertenece', PerteneceController::class);

// enrutamiento adicional para practicas
Route::controller(PracticaController::class)->group(function () {
    Route::get('/practica/confirmar/{practica}', 'confirmar')->name('practica.confirmar');
});

// enrutamiento adicional para pertenece
Route::controller(PerteneceController::class)->group(function () {
    Route::get('/pertenece/confirmar/{pertenece}', 'confirmar')->name('pertenece.confirmar');
});

app/Models/Alumno.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\HasMany;
use Illuminate\Support\Facades\Schema;

class Alumno extends Model
{
    use HasFactory;

    // nombre de la tabla
    protected $table = 'alumnos';

    // campos de asignacion masiva
    protected $fillable = [
        'nombre', 'apellidos', 'fechanacimiento', 'email', 'foto'
    ];

    // creamos un atributo estatico con los labels
    public static $labels = [
        'id' => 'ID',
        'nombre' => 'Nombre',
        'apellidos' => 'Apellidos',
        'fechanacimiento' => 'Fecha de Nacimiento',
        'email' => 'Email',
        'fotos' => 'Fotos'
    ];

    // metodo para devolver el label de un campo
    public function getAttributeLabel($key)
    {
        return self::$labels[$key] ?? $key;
    }

    public function getFields()
    {
        return Schema::getColumnListing($this->table);
    }

    // voy a crear las relaciones

    public function perteneces(): HasMany
    {
        return $this->hasMany(Pertenece::class);
    }
    public function presentas(): HasMany
    {
        return $this->hasMany(Presenta::class);
    }
}

app/Http/Controllers/AlumnoController.php
<?php

namespace App\Http\Controllers;

use App\Models\Alumno;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Storage;

class AlumnoController extends Controller
{
    /**
     * Display a listing of the resource.
     */
    public function index()
    {
        // obtener todos los alumnos
        $alumnos = Alumno::all(); // coleccion (objeto de tipo coleccion) de objetos (tipo Alumno)

        // retornar vista con datos
        return view(
            'alumno.index',
            compact('alumnos')
        );
    }

    /**
     * Esta accion solo es para cargar el formulario
     */
    public function create()
    {
        return view('alumno.create');
    }

    /**
     * Esta accion es para crear un nuevo alumno cuando pulse el boton añadir
     */
    public function store(Request $request)
    {
        // obtengo la foto subida
        $foto = $request->file('foto');

        // la almaceno en el disco publico
        $fichero = $foto->store('fotos', 'public');

        // creo el elemento en la bbdd
        $alumno = new Alumno();
        $alumno->fill($request->all());
        $alumno->foto = $fichero;
        $alumno->save();

        // redirecciono a la accion show para mostrar el registro creado
        return redirect()
            ->route('alumno.show', $alumno);
    }

    /**
     * Display the specified resource.
     */
    public function show(Alumno $alumno)
    {
        return view('alumno.show', compact('alumno'));
    }

    /**
     * Mostrar formulario para editar un alumno  y le llega el alumno a editar
     */
    public function edit(Alumno $alumno)
    {
        // mandar los datos al formulario para que los pueda editar el usuario
        return view('alumno.edit', compact('alumno'));
    }

    /**
     * recibe un alumno 
     * request (datos escritos en el formulario)
     * alumno (datos del alumno almacenados en la bbdd)
     */
    public function update(Request $request, Alumno $alumno)
    {
        if ($request->hasFile('foto')) {
            $foto = $request->file('foto');
            $fichero = $foto->store('fotos', 'public');
            Storage::disk('public')->delete($alumno->foto);
            $alumno->fill($request->all());
            $alumno->foto = $fichero;
        } else {
            $alumno->fill($request->all());
        }

        $alumno->save();

        return redirect()
            ->route('alumno.show', $alumno);
    }

    /**
     * Me llega un alumno y debo eliminarle
     */
    public function destroy(Alumno $alumno)
    {
        // eliminamos la foto
        Storage::disk('public')->delete($alumno->foto);

        // eliminamos el registro
        $alumno->delete();

        return redirect()
            ->route('alumno.index');
    }
}

resources/views/alumno/create.blade.php
@extends('layouts.main')

@section('content')
    <form action="{{ route('alumno.store') }}" method="post" enctype="multipart/form-data">
        @csrf
        <div>
            <label>Nombre</label>
            <input type="text" name="nombre">
        </div>
        <div>
            <label>Apellidos</label>
            <input type="text" name="apellidos">
        </div>
        <div>
            <label>Email</label>
            <input type="email" name="email">
        </div>
        <div>
            <label>Fecha Nacimiento</label>
            <input type="date" name="fechanacimiento">
        </div>
        <div>
            <label>Foto</label>
            <img id="preview">
            <input type="file" name="foto" id="fichero">
        </div>
        <div>
            <button type="submit">Enviar</button>
        </div>

    </form>
@endsection
@section('css')
    <style>
        .#preview {
            max-width: 100%;
            width: 200px;
        }
    </style>
@endsection

resources/views/alumno/edit.blade.php
@extends('layouts.main')

@section('content')
    <form action="{{ route('alumno.update', $alumno) }}" method="post" enctype="multipart/form-data">
        @csrf
        @method('put')
        <div>
            <label>Nombre</label>
            <input type="text" name="nombre" value="{{ $alumno->nombre }}" required>
        </div>
        <div>
            <label>Apellidos</label>
            <input type="text" name="apellidos" value="{{ $alumno->apellidos }}" required>
        </div>
        <div>
            <label>Email</label>
            <input type="email" name="email" value="{{ $alumno->email }}" required>
        </div>
        <div>
            <label>Fecha Nacimiento</label>
            <input type="date" name="fechanacimiento" value="{{ $alumno->fechanacimiento }}" required>
        </div>
        <div>
            <label>Foto</label>
            <img src="{{ asset('storage/' . $alumno->foto) }}" id="preview">
            <input type="file" name="foto" value="{{ $alumno->foto }}" id="fichero">
        </div>
        <div>
            <button type="submit">Enviar</button>
        </div>
    </form>
@endsection
@section('css')
    <style>
        #preview {
            max-width: 100%;
            width: 200px;
        }
    </style>
@endsection

resources/views/alumno/index.blade.php
@extends('layouts.main')

@section('content')
    {{-- muestro todos los alumnos que me manda el controlador --}}
    @foreach ($alumnos as $alumno)
        <ul>
            <li>id:{{ $alumno->id }}</li>
            <li>Nombre:{{ $alumno->nombre }}</li>
            <li>Apellidos:{{ $alumno->apellidos }}</li>
            <li>Email:{{ $alumno->email }}</li>
            <li>fecha Nacimiento:{{ $alumno->fechanacimiento }}</li>
            <li>Foto: {{ $alumno->foto }}</li>
            <li>
                <a href="{{ route('alumno.show', $alumno) }}">Ver</a>
                <a href="{{ route('alumno.edit', $alumno) }}">Actualizar</a>
                <form action="{{ route('alumno.destroy', $alumno) }}" method="post" id="eliminar">
                    @csrf
                    @method('delete')
                    <button type="submit">Borrar</button>
                </form>
            </li>
        </ul>
    @endforeach
@endsection

resources/views/alumno/show.blade.php
@extends('layouts.main')

@section('content')
    <ul>
        <li>id:{{ $alumno->id }}</li>
        <li>Nombre:{{ $alumno->nombre }}</li>
        <li>Apellidos:{{ $alumno->apellidos }}</li>
        <li>Email:{{ $alumno->email }}</li>
        <li>fecha Nacimiento:{{ $alumno->fechanacimiento }}</li>
        <li>Foto: <br>
            <img class="imagen" src="{{ asset('storage/' . $alumno->foto) }}">
        </li>
        <li>
            <a href="{{ route('alumno.edit', $alumno) }}">Actualizar</a>
            <form action="{{ route('alumno.destroy', $alumno) }}" method="post" id="eliminar">
                @csrf
                @method('delete')
                <button type="submit">Borrar</button>
            </form>
        </li>
    </ul>
@endsection

@section('css')
    <style>
        .imagen {
            max-width: 100%;
            width: 200px;
        }
    </style>
@endsection